/* jshint -W100 */

function specialCharToEntity(s) {  
  var charCode = '&#' + s.charCodeAt(0) + ';';
  return charCode ? charCode : s;
}

function htmlEncode(s){
  var specialCharEntities = /[℠‑¡¢£¤¥¦§¨©ª«¬­®¯¯°±±²³´µ¶·¸¹º»¼½½¾¿ÀÁÂÃÄÅÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖ×ØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõö÷øùúûüýþÿĀāĂăĄąĆćĈĉĊċČčĎďĐđĒēĖėĘęĚěĜĝĞğĠġĢĤĥĦħĨĩĪīĮįİıĲĳĴĵĶķĸĹĺĻļĽľĿŀŁłŃńŅņŇňŉŊŋŌōŐőŒœŔŕŖŗŘřŚśŜŝŞşŠšŢţŤťŦŧŨũŪūŬŭŮůŰűŲųŴŵŶŷŸŹźŻżŽžƒƵǵȷˆˇ˘˙˚˛˜˝ΑΒΓΔΕΖΗΘΙΚΛΜΝΞΟΠΡΣΤΥΦΧΨΩΩαβγδεζηθικλμνξοπρςςστυφχψωϑϑϒϕϖϖϜϝϰϱϵ϶ЁЂЃЄЅІЇЈЉЊЋЌЎЏАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюяёђѓєѕіїјљњћќўџ        ​‌‍‎‏‐–—―‖‘’’‚“””“„†‡‡••‥……‰‱′″‴‵‹›‾⁁⁃⁄⁏⁗ ⁠⁡⁢⁣€ℂ℅ℊℋℌℍℎℏℐℑℑℒℓℕ№℗℘℘ℙℚℛℜℜℝ℞™ℤ℧ℨ℩ℬℭℯℰℱℳℴℵℵℶℷℸⅅⅆⅇⅈ⅓⅔⅕⅖⅗⅘⅙⅚⅛⅜⅝⅞←←↑↑→→↓↓↔↔↕↖↗↘↙↚↛↝↞↟↠↡↢↣↤↥↦↧↩↪↫↬↭↮↰↱↲↳↵↶↷↺↻↼↽↾↿⇀⇁⇂⇃⇄⇅⇆⇇⇈⇉⇊⇋⇌⇍⇎⇏⇐⇑⇒⇓⇔⇔⇕⇖⇗⇘⇙⇚⇛⇝⇤⇥⇵⇽⇾⇿∀∁∂∃∄∅∅∇∈∈∉∉∋∋∌∏∐∑−∓∔∖∗∘√∝∝∞∟∠∠∡∢∣∤∥∦∧∧∨∨∩∪∫∬∭∮∯∰∱∲∳∴∴∵∶∷∸∺∻∼∼∽∾∿≀≁≂≃≄≅≆≇≈≈≉≊≋≌≍≎≏≐≑≒≓≔≕≖≗≙≚≜≟≠≡≢≤≤≥≥≦≧≨≩≪≫≬≭≮≯≰≱≲≳≴≵≶≷≸≹≺≻≼≽≾≿⊀⊁⊂⊂⊃⊃⊄⊅⊆⊆⊇⊇⊈⊉⊊⊋⊍⊎⊏⊐⊑⊒⊓⊔⊕⊖⊗⊘⊙⊚⊛⊝⊞⊟⊠⊡⊢⊣⊤⊥⊧⊨⊩⊪⊫⊬⊭⊮⊯⊰⊲⊳⊴⊵⊶⊷⊸⊹⊺⊻⊽⊾⊿⋀⋁⋂⋃⋄⋅⋆⋇⋈⋉⋊⋋⋌⋍⋎⋏⋐⋑⋒⋓⋔⋕⋖⋗⋘⋙⋚⋛⋞⋟⋠⋡⋢⋣⋦⋧⋨⋩⋪⋫⋬⋭⋮⋯⋰⋱⋲⋳⋴⋵⋶⋷⋹⋺⋻⋼⋽⋾⌅⌆⌈⌉⌊⌋⌌⌍⌎⌏⌐⌒⌓⌕⌖⌜⌝⌞⌟⌢⌣〈〉⌭⌮⌶⌽⌿⍼⎰⎱⎴⎵⎶⏜⏝⏞⏟⏢⏧␣Ⓢ─│┌┐└┘├┤┬┴┼═║╒╓╔╕╖╗╘╙╚╛╜╝╞╟╠╡╢╣╤╥╦╧╨╩╪╫╬▀▄█░▒▓□▪▫▭▮▱△▴▵▸▹▽▾▿◂◃◊◊○◬◯◸◹◺◻◼★☆☎♀♂♠♠♣♣♥♥♦♪♭♮♯✓✗✠✶❘❲❳⟈⟉⟦⟧⟨⟩⟪⟫⟬⟭⟵⟶⟷⟸⟹⟺⟼⟿⤂⤃⤄⤅⤌⤍⤎⤏⤐⤑⤒⤓⤖⤙⤚⤛⤜⤝⤞⤟⤠⤣⤤⤥⤦⤧⤨⤩⤪⤳⤵⤶⤷⤸⤹⤼⤽⥅⥈⥉⥊⥋⥎⥏⥐⥑⥒⥓⥔⥕⥖⥗⥘⥙⥚⥛⥜⥝⥞⥟⥠⥡⥢⥣⥤⥥⥦⥧⥨⥩⥪⥫⥬⥭⥮⥯⥰⥱⥲⥳⥴⥵⥶⥸⥹⥻⥼⥽⥾⥿⦅⦆⦋⦌⦍⦎⦏⦐⦑⦒⦓⦔⦕⦖⦚⦜⦝⦤⦥⦦⦧⦨⦩⦪⦫⦬⦭⦮⦯⦰⦱⦲⦳⦴⦵⦶⦷⦹⦻⦼⦾⦿⧀⧁⧂⧃⧄⧅⧉⧍⧎⧏⧐⧜⧝⧞⧣⧤⧥⧫⧴⧶⨀⨁⨂⨄⨆⨌⨍⨐⨑⨒⨓⨔⨕⨖⨗⨢⨣⨤⨥⨦⨧⨩⨪⨭⨮⨯⨰⨱⨳⨴⨵⨶⨷⨸⨹⨺⨻⨼⨿⩀⩂⩃⩄⩅⩆⩇⩈⩉⩊⩋⩌⩍⩐⩓⩔⩕⩖⩗⩘⩚⩛⩜⩝⩟⩦⩪⩭⩮⩯⩰⩱⩲⩳⩴⩵⩷⩸⩹⩺⩻⩼⩽⩾⩿⪀⪁⪂⪃⪄⪅⪆⪇⪈⪉⪊⪋⪌⪍⪎⪏⪐⪑⪒⪓⪔⪕⪖⪗⪘⪙⪚⪝⪞⪟⪠⪡⪢⪤⪥⪦⪧⪨⪩⪪⪫⪬⪭⪮⪯⪰⪳⪴⪵⪶⪷⪸⪹⪺⪻⪼⪽⪾⪿⫀⫁⫂⫃⫄⫅⫆⫇⫈⫋⫌⫏⫐⫑⫒⫓⫔⫕⫖⫗⫘⫙⫚⫛⫤⫦⫧⫨⫩⫫⫬⫭⫮⫯⫰⫱⫲⫳⫽ﬀﬁﬂﬃﬄ풜풞풟풢풥풦풩풪풫풬풮풯풰풱풲풳풴풵풶풷풸풹풻풽풾풿퓀퓁퓂퓃퓅퓆퓇퓈퓉퓊퓋퓌퓍퓎퓏프픅픇픈픉픊픍픎픏픐픑픒픓픔픖픗픘픙픚픛픜픞픟픠픡픢픣픤픥픦픧픨픩픪픫픬픭픮픯픰픱픲픳픴픵픶픷픸픹픻피픽픾핀핁핂핃필핆핊핋핌핍핎핏핐핒핓핔핕핖핗하학핚핛한핝핞핟할핡핢핣핤핥핦핧함합핪\핫]/g;
    return s.replace(specialCharEntities, specialCharToEntity);
}

module.exports.htmlEncode = htmlEncode;
